﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.UltraWinSchedule;
using Infragistics.Win.UltraWinSchedule.MonthViewMulti;

namespace WG_DisableDates
{
    public partial class Form1 : Form
    {


        public Form1()
        {
            InitializeComponent();
        }

        private void ultraCalendarInfo1_BeforeActiveDayChanged(object sender, Infragistics.Win.UltraWinSchedule.BeforeActiveDayChangedEventArgs e)
        {
            e.Cancel = this.ultraMonthViewMulti1.ChangeActiveDay == false;
            this.ultraMonthViewMulti1.ChangeActiveDay = true;
        }

    }


    public class MyCalendar : UltraMonthViewMulti
    {
        //Message number for Left Button Click message
        private const int WM_LBUTTONDOWN = 0x0201;
        //Message number for Left Button Double Click message
        private const int WM_LBUTTONDBLCLK = 0x0203;

        bool changeActiveDay = true;

        public bool ChangeActiveDay
        {
            get { return changeActiveDay; }
            set { changeActiveDay = value; }
        }

        protected override void WndProc(ref Message m)
        {
            if (m.Msg == WM_LBUTTONDOWN || m.Msg == WM_LBUTTONDBLCLK)
            {
                var mousePos = this.PointToClient(Cursor.Position);
                var element = this.UIElement.ElementFromPoint(mousePos);

                if (element == null)
                    return;

                var day = element.GetContext(typeof(Infragistics.Win.UltraWinSchedule.Day)) 
                    as Infragistics.Win.UltraWinSchedule.Day;

                if (day == null)
                    return;

                changeActiveDay = day.EnabledResolved;

            }
            base.WndProc(ref m);
        }
    }
}
